require "defines"
require "config"

--if 1 then return end
init=function()
    global.types={}
    global.dummy_types={}
    for _,p in pairs(game.entity_prototypes) do
        found=string.find(p.name,"%-electric%-placement%-dummy")
        if found then
            local name=p.name:sub(1,found-1)
            global.dummy_types[p.name]={name,name.."-electric-shooting-dummy"}
            global.types[name]=true
        end
    end
    global.turrets=global.turrets or {}
    global.to_deactivate=global.to_deactivate or {}
end
script.on_init(function()  init() end)
script.on_configuration_changed(function() init() end)

function new(ent)
    local s=ent.surface
    local f=ent.force
    local p=ent.position
    local name=ent.name
    
    local turret=s.create_entity{name=global.dummy_types[name][1],position=p,force=f}
    local dummy=s.create_entity{name=global.dummy_types[name][2],position=p,force=f}
    dummy.destructible=false
    dummy.minable=false
    turret.active=false
    
    local t=global.turrets
    t[p.x]=t[p.x] or {}
    t[p.x][p.y]={turret, dummy}
    ent.destroy()
end
script.on_event({defines.events.on_built_entity,defines.events.on_robot_built_entity},function(e)
    if global.dummy_types[e.created_entity.name] then
        new(e.created_entity)
    end
end)

function activate(expl)
    local x=expl.position.x
    local y=expl.position.y
    local t=global.turrets
    if t[x] and t[x][y] and t[x][y][1].valid then 
        t[x][y][1].active=true
        local tick=game.tick+config.update
        global.to_deactivate[tick]=global.to_deactivate[tick] or {}
        table.insert(global.to_deactivate[tick],t[x][y][1])
    end
end
script.on_event(defines.events.on_trigger_created_entity,function(e)
    if e.entity.name=="electrified-turret-activation" then
        activate(e.entity)
    end
end)

function deactivate(tick)
    local turrets=global.to_deactivate[tick]
    for i=1,#turrets do
        local t=turrets[i]
        if t.valid then
            t.active=false
        end
    end
    global.to_deactivate[tick]=nil
end
script.on_event(defines.events.on_tick,function(e)
    if global.to_deactivate[e.tick] then deactivate(e.tick) end
end)

function die(ent)
    local x=ent.position.x
    local y=ent.position.y
    local t=global.turrets
    if t[x] and t[x][y] and t[x][y][2].valid then 
        t[x][y][2].destroy()
        t[x][y]=nil
        t[x]=next(t[x]) and t[x] or nil
    end
end
script.on_event({defines.events.on_entity_died,defines.events.on_robot_pre_mined_item,defines.events.on_preplayer_mined_item,},
    function(e)
        if global.types[e.entity.name] then
            die(e.entity)
        end
    end)
