require "util"
require "config"
local empty="__core__/graphics/empty.png"
--empty graphics and animation
local temp={
        filename = empty,
        priority = "high",
        width = 1,
        height = 1,
        frame_count = 1,
        direction_count=1,
        shift = {0,0}
      }
--dummy explosion to detect stuff happenning
local activation=table.deepcopy(data.raw["explosion"]["explosion"])
    activation.name = "electrified-turret-activation"
    activation.animations={{  
        filename = "__core__/graphics/empty.png",
        priority = "extra-high",
        width = 1,height = 1,frame_count = 1,animation_speed = 1
        }}
    activation.light=nil
    activation.smoke=nil
    activation.smoke_count=nil
    activation.smoke_slow_down=nil
    activation.sound=nil
data:extend{activation}
    
function process(t)
    --adds a pair of dummies and updates the recipes and items for each ammo-turret
    t.order="o-o-o"
    --shooting dummy
    local s=table.deepcopy(data.raw["electric-turret"]["laser-turret"])
    s.name=t.name.."-electric-shooting-dummy"
    s.icon=t.icon
    s.flags={}
    s.max_health=t.max_health
    s.selection_box={{0,0},{0,0}}
    s.folded_animation = temp 
    s.preparing_animation = temp
    s.prepared_animation =temp
    s.folding_animation=temp
    s.base_picture = temp
    s.energy_source ={--these are default values from my mod, 
    --they can be overriden by values specified in source turret t (that happens way below this line)
      type = "electric",
      buffer_capacity = "48kJ",
      input_flow_limit = "96kW",
      drain = "12kW",
      usage_priority = "primary-input"
    }
    --custom energy requirements
    if t.energy_source then
        for k,v in pairs(t.energy_source) do
            s.energy_source[k]=v
        end
    end
    s.attack_parameters ={
        type = "projectile",
        ammo_category = "electric",
        cooldown = config.update,
        projectile_center = {0, 0},
        projectile_creation_distance = 0,
        range = t.attack_parameters.range,
        damage_modifier = 0,
        ammo_type ={
            type = "projectile",
            category = "laser-turret",
            --energy spent per activation is configurable too
            energy_consumption = t.ammo_type and t.ammo_type.energy_consumption or "1J",
            action ={
                type = "direct",
                action_delivery ={
                    type="instant",
                    source_effects ={
                        type = "create-entity",
                        entity_name = "electrified-turret-activation",
                        trigger_created_entity=true
                        }
                    }
                }
            },
        sound=nil
        }
    --building dummy
    --this one is needed to trigger electric network display
    local d=table.deepcopy(s)
    d.name=t.name.."-electric-placement-dummy"
    d.folded_animation = t.folded_animation 
    d.preparing_animation = temp
    d.prepared_animation =temp
    d.folding_animation=temp
    d.base_picture = t.base_picture
    d.attack_parameters.range=t.attack_parameters.range
    d.attack_parameters.cooldown=t.attack_parameters.cooldown
    d.attack_parameters.damage_modifier=t.attack_parameters.damage_modifier
    d.attack_parameters.ammo_category=t.attack_parameters.ammo_category
    
    for _,item in pairs(data.raw.item) do
        if item.place_result==t.name then
            item.place_result=d.name
        end
    end
    data:extend{d,s}
end

for n,t in pairs(data.raw["ammo-turret"]) do
    if not config.exceptions[n] then
        process(t)
    end
end
